"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLocalIdentName = exports.Generator = exports.classNameAlphabet = void 0;
exports.classNameAlphabet = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
var containsNumbers = function (input) { return /\d/.test(input); };
var Generator = (function () {
    function Generator(alphabet) {
        if (alphabet === void 0) { alphabet = exports.classNameAlphabet; }
        this.counters = [];
        this.hasSafeAlphabet = true;
        if (!alphabet.length) {
            throw new Error("Alphabet must contain at least one character!");
        }
        this.alphabet = __spread(new Set(alphabet.split(""))).join("");
        if (containsNumbers(this.alphabet)) {
            this.hasSafeAlphabet = false;
            if (this.nextNotNumber(0) === -1) {
                throw new Error("Alphabet must contain at least one non-numeric character!");
            }
        }
    }
    Generator.prototype.next = function () {
        return this.increment().countersToString();
    };
    Generator.prototype.countersToString = function () {
        var _a = this, alphabet = _a.alphabet, counters = _a.counters;
        return counters.map(function (counter) { return alphabet[counter]; }).join("");
    };
    Generator.prototype.increment = function () {
        var _this = this;
        var _a = this, digitsCount = _a.alphabet.length, length = _a.counters.length;
        var lastDigit = digitsCount - 1;
        for (var i = 0; i < length; i++) {
            if (this.counters[i] < lastDigit) {
                if (i === 0) {
                    var next = this.nextNotNumber(this.counters[i] + 1);
                    if (next !== -1) {
                        this.counters[i] = next;
                        return this;
                    }
                    else if (i < length - 1) {
                        this.counters[i] = this.nextNotNumber(0);
                    }
                }
                else {
                    ++this.counters[i];
                    return this;
                }
            }
            else if (i < length - 1) {
                this.counters[i] = i === 0 ? this.nextNotNumber(0) : 0;
            }
        }
        this.counters = Array.apply(null, Array(length + 1)).map(function (_, index) {
            return index === 0 ? _this.nextNotNumber(0) : 0;
        });
        return this;
    };
    Generator.prototype.isNumber = function (charIndex) {
        return containsNumbers(this.alphabet[charIndex]);
    };
    Generator.prototype.nextNotNumber = function (charIndex) {
        if (this.hasSafeAlphabet) {
            return charIndex;
        }
        for (var k = charIndex; k < this.alphabet.length; k++) {
            if (!this.isNumber(k)) {
                return k;
            }
        }
        return -1;
    };
    return Generator;
}());
exports.Generator = Generator;
var createGenerator = function (alphabet, prefix, suffix) {
    var generator = new Generator(alphabet);
    if (prefix || suffix) {
        var safePrefix_1 = !!prefix && containsNumbers(prefix.charAt(0)) ? "_" + prefix : prefix;
        return function () { return "" + (safePrefix_1 || "") + generator.next() + (suffix || ""); };
    }
    return generator.next.bind(generator);
};
exports.getLocalIdentName = function (alphabet, prefix, suffix) {
    var classes = {};
    var classNameGenerator = createGenerator(alphabet, prefix, suffix);
    var getClassName = function (path, localName) {
        var _a;
        classes[path] || (classes[path] = {});
        (_a = classes[path])[localName] || (_a[localName] = classNameGenerator());
        return classes[path][localName];
    };
    return function (_a, _, localName) {
        var resourcePath = _a.resourcePath;
        return getClassName(resourcePath, localName);
    };
};
